﻿using UnityEngine;
using System.Collections;

public class PlayerController : MonoBehaviour {

	Animator animator;
	private Rigidbody physiscBody;
	public float movespeed;	
	// Use this for initialization
	void Start () {
		animator = GetComponent<Animator> ();
		animator.SetInteger ("PlayerAnimState", 0);
		physiscBody = GetComponent<Rigidbody>();
	}
	
	// Update is called once per frame
	void Update () {
		bool isInAction = !animator.GetCurrentAnimatorStateInfo (0).loop;
		if (isInAction) {
			if (animator.GetCurrentAnimatorStateInfo (0).normalizedTime > 1.0 && !animator.IsInTransition (0))
				animator.SetInteger ("PlayerAnimState", 0);
		} else {

			//if(Input.GetKeyDown("0")) //idle
			//	animator.SetInteger ("PlayerAnimState", 0);
			//if(Input.GetKeyDown("1")) //walk
			//	animator.SetInteger ("PlayerAnimState", 1);
			//if(Input.GetKeyDown("2")) //run
			//	animator.SetInteger ("PlayerAnimState", 2);

			if(Input.GetKeyDown("space")) //attack
			{
				if(Random.value < 0.5)
					animator.SetInteger ("PlayerAnimState", 3); //attack1
				else
					animator.SetInteger ("PlayerAnimState", 4); //attack2
				return;
			}
			if(Input.GetKeyDown("b"))
			{
				animator.SetInteger ("PlayerAnimState", 5); //block
				return;
			}
				
			bool left = false;
			bool right = false;
			bool up = false;
			bool down = false;

			left = Input.GetKey ("left") || Input.GetAxis ("Horizontal") < 0;
			right = Input.GetKey ("right") || Input.GetAxis ("Horizontal") > 0;
			up = (Input.GetKey("up") || Input.GetAxis("Vertical") > 0);
			down = (Input.GetKey("down") || Input.GetAxis("Vertical") < 0);

			Vector3 move = new Vector3(0,0,0);
			if(up)move.z += 1;
			if(down)move.z -= 1;
			move.Normalize();
			if(move.magnitude > 0)
				animator.SetInteger ("PlayerAnimState", 1);
			else
				animator.SetInteger ("PlayerAnimState", 0);
			

			float yaw = 0;
			if(left)yaw -= 1;
			if(right)yaw += 1;

			transform.Rotate(new Vector3(0.0f,yaw,0.0f));
			move = transform.rotation * move;

			Vector3 forcePos = new Vector3(0.0f, -0.175f, 0.0f);
			physiscBody.AddForceAtPosition(movespeed * move, forcePos);
		}
	}
}
